package rocks.zipcode.quiz5.fundamentals;

import java.util.Arrays;

/**
 * @author leon on 21/12/2018.
 */
public class StringUtils {
    public static Character getMiddleCharacter(String string) {
        return string.charAt(string.length()/2);
    }

    public static String capitalizeMiddleCharacter(String str) {
        int middle = str.length()/2;
        StringBuilder sb = new StringBuilder(str);
        sb.setCharAt(middle, Character.toUpperCase(sb.charAt(middle)));

        return sb.toString();
    }

    public static String lowerCaseMiddleCharacter(String str) {
        int middle = str.length()/2;
        StringBuilder sb = new StringBuilder(str);
        sb.setCharAt(middle, Character.toLowerCase(sb.charAt(middle)));

        return sb.toString();
    }

    public static Boolean isIsogram(String str) {
        char[] arr = str.toCharArray();
        Arrays.sort(arr);
        for (int i = 0; i <arr.length -1; i++) {
            if(arr[i] == arr[i+1]) {
                return false;
            }
        }
        return true;
    }

    public static Boolean hasDuplicateConsecutiveCharacters(String str) {
        char[] arr = str.toCharArray();
        for (int i = 0; i <arr.length -1; i++) {
            if(arr[i] == arr[i+1]) {
                return true;
            }
        }
        return false;
    }

    public static String removeConsecutiveDuplicateCharacters(String str) {
        char[] arr = str.toCharArray();
        String result = "";
        for (int i = 0; i <arr.length -1 ; i++) {
            if(arr[i] == arr[i+1]) {
                result += arr[i];
            }
        }
        return result;
    }

    public static String invertCasing(String str) {
        char[] arr = str.toCharArray();
        for (int i = 0; i <arr.length ; i++) {
            char c = arr[i];
            if(Character.isUpperCase(c)) {
                arr[i] = Character.toLowerCase(c);
            } else if(Character.isLowerCase(c)) {
                arr[i] = Character.toUpperCase(c);
            }
        }
        return new String(arr);
    }
}